c23456789a123456789b123456789c123456789d123456789e123456789f123456789g12
c  program magnz
c  compute NZ magnitude using both maximum on vertical 
c    component for r<100km and max Wood-Anderson
c    on horiz for r>100km
c  Rewrite hypoellipse arc file with mag
c  Write summary card to file33
c
c NOTE THAT THIS PROGRAM NEEDS TO BE CHANGED TO ACCOUNT
C FOR DEEP EQ.
c
c  20-feb-96 mag seems a bit low, but don't see a problem
c
      common/nzmcor/ csta(500),ccomp(500),corrn(500,3),mwt(500,3),
     & msprd(500,3),wathrm(500,3),nmsta
      common/woody/wsta(100),wcomp(100),ampwa(100),iwsta(100),
     & nampwa
      common/arc/asta(100),adist(100),depth,iasta(100),
     & rlat,rlon,rdep,nhsta
      common/arcch/hcard,pcard(100)
      common/zamps/zsta(100),zamp(100),izsta(100),nzsta
c
      dimension rtype(100),rcomp(100),rmag(100),sdist(100),wt(100),
     & rsta(100)
c
      character*115 hcard,pcard
c  Assume a0 for Richter mag=3
c  Just get mags consistent with Terry
      a0=3.0
c
c  Terry seems to use 111km per degree for calculating r
      xkmdeg=111.0
      open(21,form='formatted',status='old')
      call rdnzcr(21)
      close(21)
      open(22,form='formatted',status='old')
      call rdarc(22)
      close(22)
      open(23,form='formatted',status='old')
      call rdzamp(23)
      close(23)
      open(24,form='formatted',status='old')
      call rdwa(24)
      close(24)
c
      k=0
c
      write(6,600)
  600 format(' type sta comp    amp    nsprd corr   dist   wt  mag')
c
c  Calculate Wood-Anderson NZ magnitude for horizontals
c  Following Seis Rept and Haines, BSSA 1981
      do 100 iw=1,nampwa
      call rdist(wsta(iw),r)
      if(r.lt.100) goto 100
        call getcor(iwsta(iw),depth,rlat,rlon,
     & nmag,corr,nwt,nsprd,wathrs)
        if(ampwa(iw).lt.wathrs) nwt=0
        rdeg=r/xkmdeg
        a100=ampwa(iw)/(rdeg**(-nsprd)) 
        k=k+1
c Note that WA sta magnitudes I calculate are all off by nearly
c 0.1 s from those calculated within QED on CUSP data so put
c another correction for this
        rmag(k)=log10(a100) + a0 +corr + 0.075
        rtype(k)='WA'
        rsta(k)=wsta(iw)
        rcomp(k)=wcomp(iw)
        sdist(k)=r
        wt(k)=float(nwt)
        write(6,601) rtype(k),rsta(k),rcomp(k),ampwa(iw),nsprd,corr,
     &    sdist(k),wt(k),rmag(k)
  601   format(1x,a2,1x,a4,1x,a1,e14.4,i4,f7.2,f8.2,f4.1,f5.2)
  100 continue
c Don't use verticals if more than 8 Wood-Andersons
      kwa=k
c
      do 200 iz=1,nzsta
      call rdist(zsta(iz),r)
c      write(6,607) zsta(iz),zamp(iz),r
  607 format(' MZ sta amp dist ',a4,e14.4,f7.2)
      if(r.lt.0.0) goto 200
      call getcor(izsta(iz),depth,rlat,rlon,
     & nmag,corr,nwt,nsprd,wathrs)
      k=k+1
c Use Robinson NZ formula for max vertical amplitude
c  if r <100 km
      if(r.le.100.0) then
        sldist=sqrt(r*r+depth*depth)
        rmag(k)=log10(zamp(iz))+log10(sldist)+0.0029*sldist+corr
        nsprd=1
      else
c Use Haines formula if r>100
c  Note need a term=0.619 to match Haines zmag to Robinson zmag
c  at r=100km
        rdeg=r/xkmdeg
        a100=zamp(iz)/(rdeg**(-nsprd))
        rmag(k)=log10(a100) + a0 + corr - 0.619
      endif
      rtype(k)='MZ'
      rsta(k)=zsta(iz)
      rcomp(k)='Z'
      sdist(k)=r
      wt(k)=float(nwt)
      if(r.lt.100.0) wt(k)=0.5*wt(k)
      if(kwa.ge.8) wt(k)=0.0
      write(6,601)rtype(k),rsta(k),rcomp(k),zamp(iz),nsprd,corr,
     &    sdist(k),wt(k),rmag(k)
  603   format(1x,a2,1x,a4,1x,a1,e14.4,4x,f7.2,f8.2,f4.1,f5.2)
  200 continue
c
c  Find wtd avg magnitude
      nk=k
      rmgtot=0.0
      wtmtot=0.0
      do 300 i=1,nk
      rmgtot=rmgtot + rmag(i)*wt(i)
      wtmtot=wtmtot+wt(i)
  300 continue
      wazmag=rmgtot/wtmtot
      write(6,602) wazmag
  602 format(' computed magnitude = ',f6.2)
c
c write out arc file and summary card with magnitude
      open(22,form='formatted')
      open(33,form='formatted')
      imag=nint(10.0*wazmag)
      write(hcard(35:36),2205) imag
 2205 format(i2)
      write(22,3200) hcard
      write(33,3200) hcard
 3200 format(a115)
      do 400 i=1,nhsta
      write(22,3200) pcard(i)
  400 continue
      write(22,3210) 
 3210 format('    ')
c
  900 continue
      close(32)
      close(33)
      stop
      end
c
      subroutine getcor(ksta,depth,rlat,rlon,
     & nmag,corr,nwt,nsprd,wathrs)
      common/nzmcor/ csta(500),ccomp(500),corrn(500,3),mwt(500,3),
     & msprd(500,3),wathrm(500,3),nmsta
c
c     ksta is index to station correction
c
c for 1st version, assume shallow ie:nmag=1
c  Later calculate nmag from rlat,rlon and depth
      nmag=1
c
      corr=corrn(ksta,nmag)
      nwt=mwt(ksta,nmag)
      nsprd=msprd(ksta,nmag)
      wathrs=wathrm(ksta,nmag)
c
      return
c **** end of subroutine getcor ****
      end
c
      subroutine rdist(rsta,r)
      common/arc/asta(100),adist(100),depth,iasta(100),
     & rlat,rlon,rdep,nhsta
c
c
      do 100 ih=1,nhsta
        if(rsta.eq.asta(ih)) then
          r=adist(ih)
          return
        endif
  100 continue
      r= -1.0
      write(6,600) rsta
  600 format(' Could not find station: ',a4,' in hypoel.arc')
      return
c **** end of subroutine rdist ****
      end
c
      subroutine rdwa(nfin)
c read in list of Wood-Anderson amplitudes from getampwa
c
      common/woody/wsta(100),wcomp(100),ampwa(100),iwsta(100),
     & nampwa
      common/nzmcor/ csta(500),ccomp(500),corrn(500,3),mwt(500,3),
     & msprd(500,3),wathrm(500,3),nmsta
      character*2 c2
c
c
      i=1
    5 continue
      read(nfin,2400,err=5,end=900) wsta(i),wcomp(i),ampwa(i),c2
 2400 format(1x,a4,1x,a1,4x,e14.4,t1,a2)
      if((c2.eq.'95').or.(c2.eq.'96')) goto 5
c
c  find iwsta=index to station correction
        do 20 j=1,nmsta
        if((csta(j).eq.wsta(i)).and.(ccomp(j).eq.'H')) then
          iwsta(i)=j
          goto 25
        endif
   20   continue
        write(6,600) wsta(i)
  600   format('**** W-A station ',a4,' not found in mag ',
     &  'correction list, use generic spread and 0 corr')
c        write(6,601) wsta(i),wsta(i)
  601   format(' W-A sta ', a4,e14.4)
c        write(6,602) (csta(j),csta(j),j=1,nmsta)
  602 format(' corr sta ',4(a4,e14.4))
        iwsta(i)=300
c
   25 i=i+1
      goto 5
  900 continue
      nampwa=i-1
      return
c **** end of subroutine rdwa ***
      end
c
      subroutine rdzamp(nfin)
c read in phase file with max zamps on it - created by addzamp
c  from output of xpick and getzamp
c
      common/zamps/zsta(100),zamp(100),izsta(100),nzsta
      common/zampch/zcard(100)
      common/nzmcor/ csta(500),ccomp(500),corrn(500,3),mwt(500,3),
     & msprd(500,3),wathrm(500,3),nmsta
c
      character*115 zcard
      character*2 c2
      blank='    '
c
      i=1
    5 continue
      read(nfin,2300,err=5,end=900)zcard(i),zsta(i),zamp(i),c2
 2300 format(a115,t1,a4,t113,f4.0,t1,a2)
      if((c2.eq.'95').or.(c2.eq.'96')) goto 5
      if(zsta(i).eq.blank) goto 5
      if(zamp(i).eq.0) goto 5
c
c  find izsta=index to station correction
        do 20 j=1,nmsta
        if((csta(j).eq.zsta(i)).and.(ccomp(j).eq.'Z')) then
          izsta(i)=j
          goto 25
        endif
   20   continue
        write(6,600) zsta(i)
  600   format('**** zamp station ',a4,' not found in mag ',
     &  'correction list, use generic spread and 0 corr')
c        write(6,601) zsta(i),zsta(i)
  601   format(' MZ sta ', a4,e14.4)
c        write(6,602) (csta(j),csta(j),j=1,nmsta)
  602 format(' corr sta ',4(a4,e14.4))
        izsta(i)=300
c
   25 i=i+1
      goto 5
  900 continue
      nzsta=i-1
      return
c **** end of subroutine rdzamp ***
      end
c
      subroutine rdarc(nfin)
c  read in hypoellipse arc file
c  hypocenter followed by phase cards
c
      common/arc/asta(100),adist(100),depth,iasta(100),
     & rlat,rlon,rdep,nhsta
      common/arcch/hcard,pcard(100)
      common/nzmcor/ csta(500),ccomp(500),corrn(500,3),mwt(500,3),
     & msprd(500,3),wathrm(500,3),nmsta
c
      character*115 hcard,pcard
      character*2 c1
      blank='    '
c
      read(nfin,2200) hcard,lat,xlat,lon,xlon,depth
 2200 format(a115,t15,i2,1x,f4.2,i3,1x,f4.2,f5.2)
      i=1
    5 continue
      read(nfin,2201,end=900)pcard(i),c1,asta(i),edist
 2201 format(a115,t1,a2,t1,a4,t25,f4.1)
c  check for hyp card from xpick that looks like phase card
c  also do not expect amplitudes for transect stations (SI..)
      if(c1(1:1).eq.'9') goto 5
      if(c1.eq.'SI') goto 5
      if(asta(i).eq.blank) goto 5
      adist(i)=sqrt(depth*depth+edist*edist)
        do 20 j=1,nmsta
        if(csta(j).eq.asta(i)) then
          iasta(i)=j
          goto 25
        endif
   20   continue
        write(6,600) asta(i)
  600   format('**** Hypoel station ',a4,' not found in mag ',
     &  'correction list, use generic spread and 0 corr')
        iasta(i)=300
c
   25 i=i+1
      goto 5
  900 continue
      nhsta=i-1
      return
c **** end of subroutine rdarc ***
      end
c
      subroutine rdnzcr(nfin)
c  read in New Zealand magnitude correction file from T. Webb
c
cZN OUZ  Z EAR M1   -1.17   2   2   0.0   0.0   6.322141E-2
c23456789a123456789b123456789c123456789d123456789e123456789f123456789g12
c
      common/nzmcor/ csta(500),ccomp(500),corrn(500,3),mwt(500,3),
     & msprd(500,3),wathrm(500,3),nmsta
      character*60 card
c
      blank='    '
c
      i=0
c      write(6,600)
  600 format(' st comp mtype cor wt msprd wathres')
    5 continue
      read(nfin,2101,err=5,end=900) card
 2101 format(a60)
      read(card,2100,end=900) st,co,mtype,cor,mw,m,th
      if(st.eq.blank) goto 5
 2100 format(4x,a4,1x,a1,t17,i1,t21,f5.2,3x,i1,3x,i1,t40,f6.1)
c      write(6,601) st,co,mtype,cor,mw,m,th
  601 format(1x,a4,1x,a1,1x,i1,1x,f5.2,2(1x,i1),1x,f6.1)
      if(i.eq.0) then
        i=1
        csta(i)=st
        ccomp(i)=co
      else
      if((st.ne.csta(i)).or.(co.ne.ccomp(i))) then
        i=i+1
        csta(i)=st
        ccomp(i)=co
      endif
      endif
      j=mtype
      corrn(i,j)=cor
      mwt(i,j)=mw
      msprd(i,j)=m
      wathrm(i,j)=th
      goto 5
c
  900 continue
      nmsta=i-1
c make 300th station into a generic 
      i=300
      do 100 j=1,3
      corrn(i,j)=0.0
      wathrm(i,j)=0.3
  100 continue
      mwt(i,1)=2
      mwt(i,2)=0
c  Assume unknown stations are S Is for Fiord
      mwt(i,3)=2
      msprd(i,1)=2
      msprd(i,2)=1
      msprd(i,3)=1
c
      return
c **** end of subroutine rdnzcr ****
      end
c
